<template>
  <div
    class="c-input box-border inline-flex flex-col w-full h-12 relative text-base align-middle"
    @mouseover="handleInputContainerMouseover"
    @mouseleave="handleInputContainerMouseleave"
    @mousedown="focus"
    @click.stop="focus"
  >
    <div
      class="c-input__wrapper inline-flex grow items-center justify-center py-3 px-4 bg-white border-2 rounded-[10px]"
      :class="{
        'border-blue-500': isFocused && !isDisabled,
        'border-blue-400': !isDisabled && !isHovered && !isFocused,
        'border-blue-300': isHovered && !isDisabled,
        'border-blue-200': isDisabled,
        'border-red-500': hasError && !isDisabled,
        'cursor-not-allowed': isDisabled,
        'cursor-text': !isDisabled,
      }"
    >
      <input
        ref="input"
        v-model="value"
        class="c-input__el box-border grow w-full p-0 outline-none border-0 bg-white text-blue-900 disabled:cursor-not-allowed placeholder:text-blue-400"
        :name="name"
        :type="
          type === 'password' ? (showPassowrd ? 'password' : 'text') : type
        "
        :placeholder="placeholder"
        :disabled="isDisabled"
        @input="onInput"
        @focus="onFocus"
        @blur="onBlur"
        @change="onChange"
      />

      <div v-if="isAppendGroupVisible" class="c-input__append">
        <template v-if="isPasswordIconVisible">
          <component
            :is="passwordIcon"
            class="cursor-pointer"
            @click="toggleShowPassword"
          />
        </template>
      </div>
    </div>

    <div
      v-if="hasError"
      class="c-input__error-message text-red-500 text-xs leading-[22px]"
    >
      {{ upperFirst(errorMessage || validateErrorMessage!) }}
    </div>
  </div>
</template>

<script lang="ts" setup>
import { ref, computed, watch } from 'vue'
import { useField } from 'vee-validate'

import { upperFirst } from '../../utils/helpers'

import EyeShow from '../icons/eye-show.vue'
import EyeHide from '../icons/eye-hide.vue'

export interface Props {
  disabled?: boolean
  errorMessage?: string
  modelValue?: string | number | null | undefined
  name?: string
  type?: string
  placeholder?: string
}

const props = withDefaults(defineProps<Props>(), {
  placeholder: '',
  modelValue: '',
  type: 'text',
  disabled: false,
  errorMessage: '',
  name: '',
})
const emit = defineEmits<{
  (e: 'update:modelValue', payload: string): void
  (e: 'change', payload: string): void
  (e: 'input', payload: string): void
}>()

const input = ref<HTMLInputElement>()
const isDisabled = ref(props.disabled)
const isHovered = ref(false)
const isFocused = ref(false)
const showPassowrd = ref(true)
const hasError = computed(() => errors.value.length)

const {
  value,
  errorMessage: validateErrorMessage,
  errors,
  handleBlur: setValidationBlur,
  handleChange: setValidationChange,
  validate,
} = useField(() => props.name, undefined, {
  initialValue: props.modelValue,
})

const isAppendGroupVisible = computed(() => isPasswordIconVisible.value)

const isPasswordIconVisible = computed(() => props.type === 'password')
const passwordIcon = computed(() => (showPassowrd.value ? EyeShow : EyeHide))

const focus = () => {
  input.value?.focus()
}

const handleInputContainerMouseover = () => {
  isHovered.value = true
}

const handleInputContainerMouseleave = () => {
  isHovered.value = false
}

const onFocus = () => {
  isFocused.value = true
}

const onBlur = async () => {
  setValidationBlur()

  await validate()

  isFocused.value = false
}

const onInput = (event: Event) => {
  const { value } = event.target as HTMLInputElement

  emit('input', value)
  emit('update:modelValue', value)
}

const onChange = (event: Event) => {
  const { value } = event.target as HTMLInputElement

  setValidationChange(value)

  emit('change', value)
  emit('update:modelValue', value)
}

const toggleShowPassword = () => {
  showPassowrd.value = !showPassowrd.value
  focus()
}

watch(
  () => props.disabled,
  () => {
    isDisabled.value = props.disabled
  },
)
</script>
